using System;
using Games.TowerLib;
using StpWatchLib;
namespace TestTowerLib
{
    class TestTower
    {
        static void Main(string[] args)
        {

            int numRigs; // ligal value from 1 to 9
            Console.WriteLine("Enter number of rings to move from A to C");
            Console.WriteLine("The legal value of rings must be in range from 1 to 9");
            numRigs = int.Parse(Console.ReadLine());
            while (numRigs > 9 || numRigs < 1)
            {
                Console.Write("{} Illegal legal value of rings. Enter new value: ", numRigs);
                numRigs = int.Parse(Console.ReadLine());
            }
            Tower[] towers = new Tower[3];
            towers[0] = new Tower(numRigs, "A");
            towers[1] = new Tower("B");
            towers[2] = new Tower("C");
            Console.WriteLine("Press enter to start solution and start watch");
            Console.ReadLine();
            StpWatch.Start();
            HanoiTowersSolution(towers, numRigs, 0, 2);
            Console.WriteLine("The solution takes {0} seconds", StpWatch.Stop());


        }
        private static void HanoiTowersSolution(Tower[] towers, int nRings, int fromPole, int toPole)
        {
            int extraPole;
            if (nRings > 0)
            {
                extraPole = 3 - (fromPole + toPole);
                HanoiTowersSolution(towers, nRings - 1, fromPole, extraPole);
                towers[fromPole].MoveDisc(towers[toPole]);
                HanoiTowersSolution(towers, nRings - 1, extraPole, toPole);
            }

        }
    }
}
